minor bug fix
[distro-setup] / distro-begin
index 833ab0b0c829605aa06bb4b4be07464701146866..89a09babf4e1f78c6a9af33ed530985da90a0359 100755 (executable)
 #!/bin/bash -l
 # Copyright (C) 2016 Ian Kelling
-# This program is under GPL v. 3 or later, see <http://www.gnu.org/licenses/>
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# for setting up a new machine
+# usage: $0 [-r] [HOSTNAME]
+# HOSTNAME changes the machine's hostname
 
+# tips:
+# run any sudo command first so your pass is cached
+# set the scrollback to unlimited in case something goes wrong
 
-# for bootstrapping a new machine
 
-# to make ssh run better, first run this:
-sudo bash -c 'source /a/c/repos/bash/.bashrc && source /a/bin/ssh-emacs-setup'
+# send to registrar, glue records:
+# for iankelling.org:
 
+# ns1.iankelling.org 72.14.176.105
+# ns1.iankelling.org 2600:3c00::f03c:91ff:fe6d:baf8
+# ns2.iankelling.org 172.105.84.95
+# ns2.iankelling.org 2a01:7e01::f03c:91ff:feb5:baec
 
-# see t.org for OS installer notes
+# for zroe.org:
 
-# usage: $0 [OPTIONS] HOSTNAME
+# ns1.zroe.org 72.14.176.105
+# ns1.zroe.org 2600:3c00::f03c:91ff:fe6d:baf8
+# ns2.zroe.org 172.105.84.95
+# ns2.zroe.org 2a01:7e01::f03c:91ff:feb5:baec
+#
 
-# tips:
-# run any sudo command first so your pass is cached
-# set the scrollback to unlimited in case something goes wrong
 
-if [[ $EUID == 0 ]]; then
-    echo "error: do not run as root"
-    exit
-fi
 
-interactive=true  # set this to true if running by hand in emacs
-[[ $- == *i* ]] || interactive=false
+####### begin setup environment #######
 
 
+### make ssh interactive shell run better. for when running line interactively line by line
+sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
 
+
+##### setup error handling
+interactive=true  # set this to false to force set -x
+[[ $- == *i* ]] || interactive=false
 if ! $interactive; then
-    set -x
-    set -e -o pipefail
+  set -x
 fi
-set -E
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+source /a/bin/errhandle/err
+
+_errcatch_cleanup() {
+  echo 1 >~/.local/distro-begin
+}
+
+source /a/bin/distro-functions/src/package-manager-abstractions
 
-# headless=false # unused atm
-recompile=true
-# for copying to a new data fs
-bootstrapfs=false # old flag, needs new look before using.
+### setup logging
+exec &> >(sudo tee -a /var/log/distro-begin)
+echo "$0: $(date): starting now)"
+
+
+### sanity checking
+if [[ $EUID == 0 ]]; then
+  if getent passwd iank || getent passwd ian ; then
+    echo "$0: error: running as root. unprivileged user exists. use it."
+    exit 1
+  else
+    echo "$0: warning: running as root. I will setup users then exit"
+  fi
+fi
+
+
+### arg parsing
+recompile=false
+emacs=true
 while [[ $1 == -* ]]; do
-    case $1 in
-        # avoid some of the longer compilation steps,
-        # when we need to rerun because we had an error
-        -n) recompile=false; shift ;;
-    esac
+  case $1 in
+    -r) recompile=true; shift ;;
+    -e) emacs=false; shift ;;
+  esac
 done
-
 if [[ $1 ]]; then
-    host=$1
-else
-    host=$HOSTNAME
+  export HOSTNAME=$1
 fi
 
-for f in iank-dev htpc treetowl x2 frodo tp; do
-    eval "$f() { [[ $host == $f ]]; }"
-done
-has_p() { iank-dev || x2 || frodo; }
-encrypted() { has_p || tp; }
 
+##### variables/env setup
+script_dir="$(readlink -f "${BASH_SOURCE[@]}")"; script_dir=${script_dir%/*}
+# shellcheck source=./pkgs
+source $script_dir/pkgs
+set +x
+source /a/bin/distro-functions/src/identify-distros
+$interactive || set -x
+for f in kd x2 x3 frodo tp li l2 demohost kw; do
+  eval "$f() { [[ $HOSTNAME == $f ]]; }"
+done
+codename=$(debian-codename)
+has_wayland() { has_monitor && [[ $codename == buster ]]; }
+has_x() { has_monitor && [[ $codename != buster ]]; }
+has_monitor() { ! linode ; }
+linode() { l2 || li; }
+# linode actually has btrfs now, but we dont do anything with it.
+has_btrfs() { ! linode; }
+home_network() { ! linode && ! kw; }
+has_p() { ! linode; }
+encrypted() { true; }
 shopt -s extglob
-export GLOBIGNORE=*/.:*/..
-umask 0002
+export GLOBIGNORE="*/.:*/.."
+umask 022
+PATH="/a/exe:$PATH"
+sed="sed --follow-symlinks"
+
+####### end setup environment #######
 
 
-####### end command line parsing
 
 
+##### begin setup encryption scripts ######
 if encrypted; then
-    # I tried making a service which was dependent on reboot.target,
-    # but it happened too late in the shutdown process.
-    sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
+  # I tried making a service which was dependent on reboot.target,
+  # but it happened too late in the shutdown process.
+  sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
 [Unit]
 Description=Turn on automatic decryption of drives on boot
-After=multi-user.target
+# This is triggered by reboot and when keyscriptoff stops.
+
+# tried using graphical.target, but it made my display manager restart before rebooting.
+# generally, I don't think targets order shutdown like they do startup.
+# So, I did systemd-analyze plot > something.svg, and picked a reliably started
+# service that happens late in the game.
+After=ntp.service
+DefaultDependencies=no
+# not sure if needed, makes sure we shut down before reboot.target
+Conflicts=reboot.target
 
 [Service]
 Type=oneshot
 RemainAfterExit=yes
 ExecStart=/bin/true
-ExecStop=/a/bin/keyscript-on
+ExecStop=/a/exe/keyscript-on
 
 [Install]
-WantedBy=multi-user.target
+WantedBy=keyscriptoff.service
 EOF
-    sudo systemctl start keyscripton.service
-    sudo systemctl enable keyscripton.service
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable keyscripton.service
 
-    sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
+  sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
 [Unit]
 Description=Turn off automatic decryption of drives on boot
 
 [Service]
 Type=oneshot
-ExecStart=/a/bin/keyscript-off
+ExecStart=/a/exe/keyscript-off
 
 [Install]
 WantedBy=multi-user.target
 EOF
-    sudo systemctl enable keyscriptoff.service
-    sudo systemctl start keyscriptoff.service
-fi
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable keyscriptoff.service
+  sudo systemctl start keyscriptoff.service
+
+  pi rsync
+
+  # from /usr/share/doc/dropbear-initramfs/README.initramfs.gz
+  tmp=$(mktemp)
+  while read -r m _; do /sbin/modinfo -F filename "$m"; done </proc/modules | \
+    sed -nr "s@^/lib/modules/$(uname -r)/kernel/drivers/net(/.*)?/([^/]+)\.ko\$@\2@p" \
+    | sudo dd of=$tmp
+  if ! diff -q /etc/initramfs-tools/modules $tmp &>/dev/null; then
+    sudo dd if=$tmp of=/etc/initramfs-tools/modules
+    sudo /usr/sbin/update-initramfs -u -k all
+  fi
+  # initram auth keys get setup with rootsshsync
+  $script_dir/rootsshsync
+  # then for remote unlock, ssh and do this once per crypt disk:
+  # echo -n PASS >/lib/cryptsetup/passfifo
+  # or for buster+
+  # cryptroot-unlock
 
-if iank-dev; then
-    desktop=$(ssh root@iankelling.org grep desktop /etc/hosts | grep -o "^.* ")
-    if $bootstrapfs; then
-        # for bootstrapping at a new job:
-        cp="scp $desktop:"
-        # for moving to a new hd, change $cp to move between filesystems
-        mkdir -p /a/bin
-        chown -R ian:ian /a
-        $cp/a/c /a
-        $cp/a/c/bin/{bash-programs-by-ian,distro-begin,distro-functions,input-setup.sh} /a/bin
-        echo -e \\n\\n\\n | ssh-keygen -t rsa
-    fi
 fi
-
-# this script has been designed to be idempotent
-# todo, it would be nice to cut down on some of the output
+##### end setup encryption scripts ######
 
 
-# output is below so shellcheck can verify sources
-for x in /a/bin/bash-programs-by-ian/repos/{errhandle,tee-unique,lnf}/*-function; do
-    echo "# shellcheck source=$x";
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/errhandle/bash-trace-function
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/errhandle/errallow-function
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/errhandle/errcatch-function
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/errhandle/errexit-function
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/tee-unique/teeu-function
-    # shellcheck source=/a/bin/bash-programs-by-ian/repos/lnf/lnf-function
-    source $x
-done
-
+# disabled until its fixed up
+# install-myqueue
 
-set +e
-$interactive || errcatch
-source /a/bin/distro-functions/src/identify-distros
-echo path:$PATH
+# todo, it would be nice to cut down on some of the output
 
 
+#### rerun my fai-time scripts
+# already ran for pxe installs, but used for vps & updates
+distro=$(distro-name)
+case $distro in
+  ubuntu|debian|trisquel)
+    sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
+    ;;
+  *)
+    sudo bash -c ". /a/bin/fai/fai-wrapper &&
+/a/bin/fai/fai/config/distro-install-common/end"
+    ;;
+esac
 
-if isfedora; then
-    # comment out line disallowing calling sudo in scripts
-    sudo sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
-    # turn on magic sysrq commands for this boot cycle
-    echo 1 > sudo dd of=/proc/sys/kernel/sysrq
-    # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
-    # and you have no idea why.
-    sudo sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
-    selinuxenabled && sudo setenforce 0
+###### setup hostname
+if [[ $HOSTNAME != $(cat /etc/hostname) ]]; then
+  echo $HOSTNAME > /etc/hostname
+  hostname -F /etc/hostname
 fi
+sudo sed -i --follow-symlinks -f - /etc/hosts <<EOF
+\$a 127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME
+/^127\.0\.1\.1/d
+EOF
 
 
+##### exit first stage if running as root
+if [[ $EUID == 0 ]]; then
+  echo "$0: running as root. exiting now that users are setup"
+  exit 0
+fi
 
 
-# link files
-
-
-lnf /a/c/* /a/bin ~
-
-for x in /a/c/repos/bash/!(.git); do
-    lnf "$x" ~
-    sudo -i <<EOF
-source /a/bin/bash-programs-by-ian/repos/lnf/lnf-function
+#### setup bash for root
+for x in /a/c/{.bashrc,brc,brc2,.bash_profile,.profile,.inputrc,path_add_function}; do
+  sudo -i <<EOF
+PATH="/a/exe:$PATH"
 lnf $x /root
 EOF
 done
 
-echo path:$PATH
+###### do conflink
+# linode needs bind group before conflink
+if $linode; then
+  pi-nostart bind9
+fi
+# this needs to be before installing pacserve so we have gpg conf.
+conflink
 
+###### bash environment setup
 set +x
-errallow
+err-allow
+source /etc/profile.d/environment.sh
+# shellcheck source=./.bashrc
 source ~/.bashrc
-echo path:$PATH
-$interactive || errcatch
+err-catch
 $interactive || set -x
 
 
-# passwordless sudo
-tu /etc/sudoers <<'EOF'
-ian  ALL=(ALL)  NOPASSWD: ALL
-Defaults  env_keep += SUDOD
-EOF
-
-
-# enable magic sysrq keys. debian docs say it is already enabled by default
-isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
-
+#### setup passwordless sudo
 
+# always_set_home
+# makes ubuntu be like debian
+# https://unix.stackexchange.com/a/91572
 
-if isdebian; then
-    # add contrib non-free to sources for main
-    s sed -i 's/^\(deb.* main\).*/\1 contrib non-free/' /etc/apt/sources.list.d/*
+# umask: default setting is to have  minimum umask of 0022
+# This lets us have user-specific umasks which are more permissive.
+# I did this for transmission and set it's umask gecos on install,
+# see there for more info.
 
-    # non-existent var, as Im not planning to use stable right now
-    if isdebian-stable; then
-        code=$(debian-codename)
-        s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
-deb http://mozilla.debian.net/ $code-backports firefox-release
-deb-src http://mozilla.debian.net/ $code-backports firefox-release
-EOF
-
-        # we change the mirror from the default, so we cant use tu
-        s dd of=/etc/apt/sources.list.d/main-backports.list <<EOF
-deb http://http.debian.net/debian $code-backports main contrib non-free
-deb-src http://http.debian.net/debian $code-backports main contrib non-free
+tu /etc/sudoers <<EOF
+$USER  ALL=(ALL)  NOPASSWD: ALL
+Defaults  env_keep += SUDOD
+Defaults always_set_home
+Defaults !umask
 EOF
 
-        p update
-        # take care of mozilla signing errors in previous command
-        pi pkg-mozilla-archive-keyring
-    else
-        :
-        # this would change stable to testing, but I set that up already.
-        # It\'s just a no-op if its already testing.
-        # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
-        p update
-    fi
-fi
 
+#### setup firefox backport
+## ian: disabled. backports are not being published atm due to rust packaging issue
+# if isdeb; then
+#     codename=$(debian-codename)
+#         if isdebian-stable && has_x; then
+#             s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
+#     deb http://mozilla.debian.net/ $codename-backports firefox-release
+#     deb-src http://mozilla.debian.net/ $codename-backports firefox-release
+# EOF
+#             p update
+#             # take care of mozilla signing errors in previous command
+#             pi pkg-mozilla-archive-keyring
+#         fi
+#     p update
+# fi
+
+
+######  arch aur wrapper setup
 if isarch; then
-    #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
-    sudo pacman -S --noconfirm --needed base-devel jq
-    # pacaur seems to be the best, although it + cower has a few minor bugs,
-    # its design goals seem good, so, going for it.
-
-    aurpi() {
-        for p in "$@"; do
-            tempdir=$(mktemp -d)
-            pushd $tempdir
-            aurex "$p"
-            makepkg -sri --skippgpcheck --noconfirm
-            popd
-            rm -rf $tempdir
-        done
-    }
-    aurpi cower pacaur
-
-    # this creates ~/.gnupg. addgnupghome is broken on arch.
-    gpg -k
-    # for aur, automatically dl & add gpg keys.
-    # Just the keyserver-options line goes in dirmngr.conf once
-    # this bug is fixed: https://bugs.gnupg.org/gnupg/issue2147
-    teeu ~/.gnupg/gpg.conf <<EOF
-$(grep -o '^ *keyserver .*' ~/.gnupg/dirmngr.conf)
-keyserver-options auto-key-retrieve
-EOF
-    pi pacserve
-    x=$(mktemp); pacman.conf-insert_pacserve >$x
-    sudo dd of=/etc/pacman.conf if=$x; rm $x
-    sudo systemctl enable pacserve.service
-    sudo systemctl start pacserve.service
-
-    # strange error if just installing trash-cli: "pyalpm requires python",
-    # so I see that it requires python2, and installing that manually fixes it.
-    # I didn't see this on earlier installation, main thing which changed was
-    # pacserve, so not sure if it's related.
-    pi python2
+  #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
+  sudo pacman -S --noconfirm --needed base-devel jq
+  # pacaur seems to be the best, although it + cower has a few minor bugs,
+  # its design goals seem good, so, going for it.
+
+  aurpi() {
+    for p in "$@"; do
+      tempdir=$(mktemp -d)
+      pushd $tempdir
+      aurex "$p"
+      makepkg -sri --skippgpcheck --noconfirm
+      popd
+      rm -rf $tempdir
+    done
+  }
+  aurpi cower pacaur
+
+  pi pacserve
+
+  x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
+  sudo dd of=/etc/pacman.conf if=$x; rm $x
+  sudo systemctl enable pacserve.service
+  sudo systemctl start pacserve.service
+
 fi
 
+#### update all packages
 pup
-pi trash-cli
 
 
-###### link files ###########
-# convenient to just do all file linking in one place
-
-lnf /a/* ~
-s lnf /a/sdx{,d} /
-
-# if it wasn't set already, we could set hostname here
-#echo treetowl | s dd of=/etc/hostname
-#s hostname -F /etc/hostname
-#HOSTNAME=$(hostname)
+###### p1 packages install ######
+pi ${p1[@]}
+
+
+######## fix evbug bug ######
+case $distro in
+  trisquel|ubuntu)
+    # noticed in flidas.
+    #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
+    #https://wiki.debian.org/KernelModuleBlacklisting
+    #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
+    #but that file won't work and will get automatically reverted
+    sudo rmmod evbug ||: # might not be loaded yet
+    file=/etc/modprobe.d/evbug.conf
+    line="blacklist evbug"
+    if ! grep -xFq "$line" $file; then
+      sudo dd of=$file 2>/dev/null <<<"$line"
+      sudo depmod -a
+      sudo update-initramfs -u
+    fi
+    ;;
+esac
 
-#########################################
-# NOTE: only /a needs to be mounted for creating links!
-###########################################
 
-# todo: reconcile ~/.ssh/config work/home
-s lnf -T /q/p /p
+###### link files
+# convenient to just do all file linking in one place
+s /a/exe/lnf -T /a/bin /b
+s /a/exe/lnf -T /nocow/t /t
 if has_p; then
-    lnf -T /p/offlineimap ~/Maildir
-    lnf -T /p/News ~/News
-    # don't use /* because I don't want to require it to be mounted
-    s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
-      /q/root/.ssh /a/opt \
-      /a/c/.emacs.d ~/.unison /root
-
+  lnf -T /p/News ~/News
 fi
+s /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
+  /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
+/a/bin/ds/install-my-scripts # needed for rootsshsync cronjob
+s /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 
-s lnf /a/c/.inputrc /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 
-if [[ $HOSTNAME == htpc ]]; then
-    lnf -T /i/Videos ~/Downloads
-fi
 
-if has_p; then
-    # for dovecot
-    lnf -T /i/mboxes ~/mail
-fi
 
 
-# basic needed packages
+#### arch specific early packages
 case $(distro-name) in
-    debian)
-        pi  firefox$( isdebian-stable && e /$code-backports )
-        # for hosts which require nonfree drivers
-        case $HOSTNAME in
-            tp|x2) : ;;
-            *) pi linux-image-amd64 firmware-linux-nonfree \
-                  firmware-linux-free linux-headers-amd64
-               ;;
-        esac
-        ;;&
-    ubuntu|debian)
-        pi xmacro gtk-redshift xinput
-        ;;&
-    fedora)
-        p -y groupinstall development-tools c-development books admin-tools
-        pi redshift-gtk
-        # debian has this package patched to work, upstream is dead
-        # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
-        # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
-        # http://packages.debian.org/source/sid/xmacro
-        pi patch libXtst-devel wget man-pages # what is the ubuntu equivalent to man-pages?
-        cd $(mktemp -d)
-        wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
-        wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
-        ex *.gz
-        patch -p0 < xmacro_0.3pre-20000911-6.diff
-        cd xmacro-0.3pre-20000911.orig
-        make
-        sleep 1 # not sure why the following command couldn\'t find, so trying this
-        # no make install target
-        s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
-        ;;&
-    arch)
-        # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
-        pi xorg-server redshift xorg-xinput pkgfile libxtst xmacro
-        # like apt-cache
-        s pkgfile --update
-        ;;&
+  arch)
+    # pkgfile is like apt-cache
+    pi pkgfile
+    s pkgfile --update
+    ;;
 esac
 
-pi xbindkeys xkbset cryptsetup
-
-pi lvm2
-# enables trim for volume delete, other rare commands.
-sudo sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
-
+#### enable trim
+# enable trim for volume delete, other rare commands
+sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
 if encrypted; then
-    if isdeb; then
-        sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
-    fi
-    # does weekly trim
-    sudo systemctl enable fstrim.timer
+  # flidas or so, these units arent built-in
+  if isdeb && ! systemctl list-unit-files | grep ^fstrim.timer &>/dev/null ; then
+    sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
+  fi
+  # does weekly trim
+  sudo systemctl enable fstrim.timer
 fi
 
-if has_p; then
-    # relatime is default, but it still significantly increases writes
-    # in comparison because it writes on the first read after each
-    # write.
-    #
-    dirs=(/i /mnt/{1,2,3,4,5,6,7,8,9})
-    if ! frodo; then
-        dirs+=(/q)
+##### make extra dirs
+dirs=(/mnt/{1,2,3,4,5,6,7,8,9} /nocow/t)
+s mkdir -p "${dirs[@]}"
+s chown $USER:$USER  "${dirs[@]}"
+
+###### setup /i
+if home_network; then
+  tu /etc/fstab <<'EOF'
+/i/w  /w  none  bind,noauto  0 0
+/i/k  /k  none  bind,noauto  0 0
+EOF
+  if ! mountpoint /kr; then
+    s mkdir -p /kr
+    s chown $USER:user2 /kr
+  fi
+  if [[ $HOSTNAME == frodo ]]; then
+    tu /etc/fstab <<'EOF'
+/k  /kr  none  bind,noauto  0 0
+EOF
+  else
+    tu /etc/fstab <<'EOF'
+frodo:/k  /kr  nfs  noauto  0 0
+EOF
+  fi
+  s mkdir -p /q /i/{w,k}
+  for dir in /{i,w,k}; do
+    if mountpoint $dir; then continue; fi # already mounted
+    s mkdir -p $dir
+    s chown $USER:$USER $dir
+  done
+  # not needed for all hosts, but rather just keep it uniform
+  s mkdir -p /mnt/iroot
+  # debian auto mounting of multi-disk encrypted btrfs is busted.  It is
+  # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
+  # based on 3 of those, it creates .device units for /dev/mapper/dev...
+  # then waits endlessly for them on bootup, after the /dev/mapper disks
+  # have already been created and exist. todo: create a simple repro
+  # for this in a vm and report it upstream.
+  pi nfs-common
+  s dd of=/root/imount <<'EOF'
+#!/bin/bash
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
+set -eE -o pipefail
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+for dir in /i /mnt/iroot /k /kr /w; do
+    if ! mountpoint $dir &>/dev/null && \
+            awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
+        if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
+            mount $dir || echo "warning: failed to mount nfs on $dir"
+        else
+            mount $dir
+        fi
     fi
-    s mkdir -p "${dirs[@]}"
-    s chown ian:ian  "${dirs[@]}"
-    # ssh and probably some other things care about parent directory
-    # ownership, and ssh doesn\'t allow any group writable parent
-    # directories, so we are forced to use a directory structure similar
-    # to home directories
-    s chown root:ian /q
-    s chmod 755 /q
+done
+EOF
+  s chmod +x /root/imount
+  s dd of=/etc/systemd/system/imount.service <<EOF
+[Unit]
+Description=Mount /i and related mountpoints
+Before=syncthing@$USER.service
 
+[Service]
+Type=oneshot
+ExecStart=/root/imount
 
+[Install]
+RequiredBy=syncthing@$USER.service
+# note /kr needs networking, this target is the simplest way to
+# time it when the network should be up, but not do something
+# dumb like delay startup until the network is up. It happens
+# at some time after network.target
+WantedBy=multi-user.target
+EOF
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable imount.service
+  sudo systemctl start imount.service
 fi
+###### end setup /i
+
+##### setup /nocow.
+# a nocow dir that is common to multiple distros installed on the same system
+dir=/nocow
+if has_btrfs; then
+  if ! mountpoint $dir; then
+    subvol=/mnt/root/nocow
+    if [[ ! -e $subvol ]]; then
+      s btrfs subvolume create $subvol
+      s chown root:1000 $subvol
+      s chattr +C $subvol
+    fi
 
+    first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
+    tu /etc/fstab <<EOF
+$first_root_crypt  /nocow  btrfs  noatime,subvol=nocow  0 0
+EOF
+    s mkdir -p $dir
+    s chown $USER:$USER $dir
+    s mount $dir
+  fi
+else
+  sudo mkdir -p $dir
+fi
 
-/a/bin/conflink
 
+##### setup email
+mail-setup
 
-# work desktop doesnt need gpg stuff, but it doesnt hurt
-s dd of=/etc/profile.d/environment.sh <<'EOF'
-# IAN: EDIT THIS FROM /a/bin/distro-begin
+#### ubuntu nicety
+if isubuntu; then
+  # disable crash report annoying dialogs.
+  s dd of=/etc/default/apport <<<'enabled=0'
+fi
 
-if [ -f $HOME/path_add-function ]; then
-    . $HOME/path_add-function
-    path_add /usr/sbin /usr/local/sbin /sbin
-    path_add /a/bin /a/opt/bin $HOME/.cabal/bin
 
-    if [ -r /etc/alternatives/java_sdk ]; then
-        export JAVA_HOME=/etc/alternatives/java_sdk
-        path_add /etc/alternatives/java_sdk
-    fi
-fi
 
-export EDITOR="emacsclient"
-# this makes emacsclient file/-c start a server instance if none is running,
-# instead of some alternate editor logic
-export ALTERNATE_EDITOR=""
-
-# ubuntu starts gpg agent automatically with  /etc/X11/Xsession.d/90gpg-agent.
-# fedora doesn't, which left me to figure this out, and google was no help.
-# fedora documentation is often quite bad :(
-# This is mostly copied from that file.
-# Main difference is that we eval the result of starting gpg-agent,
-# while that file executes it through xsession specific var.
-# Also make sourcing the pidfile make more sense.
-# End result should be the same afaik.
-# for gpg-agent to work when calling gpg from the command line,
-# we need an environment variable that is setup via the eval.
-# which is why we do this upon login, so it can propogate
-# It is also written to the file $HOME/.gnupg/gpg-agent-info-$(hostname)
-# I'm not aware if that is ever used, but just fyi.
-# I also added the bit about xmessaging the stderr,
-# because I'd like to know if the command fails
-if [ -f /etc/fedora-release ]; then
-    : ${GNUPGHOME=$HOME/.gnupg}
-
-    GPGAGENT=/usr/bin/gpg-agent
-    PID_FILE="$GNUPGHOME/gpg-agent-info-$(hostname)"
-
-    if ! $GPGAGENT 2>/dev/null; then
-        temp="$(mktemp)"
-        eval "$($GPGAGENT --homedir /p/do-not-delete --daemon --sh --write-env-file=$PID_FILE 2>$temp)"
-        temperr="$(<"$temp")"
-        [ -n "$temperr" ] && xmessage "gpg-agent stderr: $temperr"
-    elif [ -r "$PID_FILE" ]; then
-        . "$PID_FILE"
-        export GPG_AGENT_INFO
-    fi
+##### install laptop hardware packages
+if tp || x2 || x3; then
+  case $distro in
+    debian)
+      pi task-laptop
+      ;;
+    ubuntu|trisquel)
+      # the exact packages that task-laptop would install, since ubuntu
+      # doesn\'t have this virtual in practice package.
+      pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
+      ;;
+    # todo: other distros unknown
+  esac
 fi
 
-# ubuntu has 002, debian has 022.
-# from what I've read, benefit of 002 makes shared groups read/write.
-# Security concern is where some unixes put everyone in a same group,
-# so if you copy files there with exact perms, that is probably not
-# what you want. I don't use a system like that, and I don't really care
-# either way, but I'd prefer
-# being able to sync file perms with ubuntu systems at work,
-# and it's easier to change the debian one.
-
-umask 002
+if has_x; then
+  ###### install X
+  pi i3
+  if isarch; then
+    # xorg-xmessage for displaying error messages.
+    # optional dependency in arch, standard elsewhere.
+    pi xorg-server xorg-xmessage xorg-xsetroot xorg-xinit
+  fi
+
+  ##### install xinput
+  case $(distro-name) in
+    trisquel|ubuntu|debian)
+      pi xinput
+      ;;
+    arch)
+      pi xorg-xinput
+      ;;
+  esac
+
+  #### install redshift
+  case $(distro-name) in
+    trisquel|ubuntu|debian)
+      # recommends gets us geoclue (for darkening automatically at night i assume),
+      # which recommends modemmanager, which is annoying to fix for the model01 keyboard.
+      pi --no-install-recommends gtk-redshift
+      ;;&
+    arch)
+      pi redshift
+      ;;&
+  esac
+
+  ##### setup X autostart
+  if isarch; then
+    # https://wiki.archlinux.org/index.php/Xinitrc
+    for homedir in /home/*; do
+      cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
+      # shellcheck disable=SC2016
+      $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
+      tee -a $homedir/.xinitrc <<'EOF'
+/a/bin/desktop-20-autostart.sh
+xsetroot -cursor_name left_ptr
+exec xmonad
 EOF
+    done
+  else
+    # todo, figure this out for arch if we ever try out gnome.
+    # install for multiple display managers in case we use one
+    dir=/etc/gdm3
+    s mkdir -p $dir/PostLogin
+    s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
+    s mkdir /etc/lightdm/lightdm.conf.d
+    s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
+[SeatDefaults]
+session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
+EOF
+  fi
 
-
-
-# emacs dependency.
-# dunno why debian installed postfix with yum-builddep emacs
-# but I will just explicitly install it here since
-# I use it for sending mail in emacs.
-if private-host; then
-    relayhost="[mail.messagingengine.com]:587"
-else
-    # ses initially suggests port 25, but I had problems connecting to that.
-    relayhost="[email-smtp.us-west-2.amazonaws.com]:587"
 fi
-if isdeb; then
-    s debconf-set-selections<<EOF
-postfix postfix/main_mailer_type select Satellite system
-postfix postfix/mailname string $host
-postfix postfix/relayhost string $relayhost
-EOF
 
-    pi postfix
-else
-    pi postfix
-    # Settings from reading the output when installing on debian,
-    # then seeing which were different in a default install on arch.
-    # I assume the same works for fedora.
-    postconfin <<EOF
-mynetworks = 127.0.0.0/8 [::ffff:127.0.0.0]/104 [::1]/128
-mailbox_size_limit = 0
-relayhost = $relayhost
-inet_interfaces = loopback-only
-EOF
+### install and configure wayland
+if has_wayland; then
+  pi sway xwayland
+  # originally used xkbcomp, documented in input-setup.sh, this doesnt
+  # work under wayland, but its still useful for creating the config,
+  # then modifying the system files.
+  s sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
+fi
 
-    s systemctl enable postfix
-    s systemctl start postfix
+##### basic graphical packages
+if has_monitor; then
+  pi konsole suckless-tools
 fi
 
 
-if isarch; then
-    # install so it's build dependencies don't get removed.
+##### install  emacs
+if $emacs; then
+  if isarch; then
+    # emacs git build was broken last time i checked,
     x=$(mktemp -d)
     pushd $x
     aurex emacs-git
@@ -492,67 +596,18 @@ if isarch; then
     popd
     rm -rf $x
     pi hunspell hunspell-en
-else
-    # to disable emacs git build,
-    # s apt-get install emacs
+  else
     if $recompile; then
-        /a/bin/buildscripts/emacs
+      /a/bin/buildscripts/emacs
     else
-        /a/bin/buildscripts/emacs -r
+      /a/bin/buildscripts/emacs --no-r
     fi
-fi
-
-# todo, figure this out for arch if we ever try out gnome.
-if ! isarch; then
-    # install for multiple display managers in case we use one
-    if isdeb; then
-        dir=/etc/gdm3
-    elif isfedora; then
-        # fedora didn\'t have the 3.
-        dir=/etc/gdm
-    fi
-    s mkdir -p $dir/PostLogin
-    s command cp /a/bin/desktop-20-autostart.sh $dir/PostLogin/Default
-    s mkdir /etc/lightdm/lightdm.conf.d
-    s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
-[SeatDefaults]
-session-setup-script=/a/bin/desktop-20-autostart.sh
-EOF
-fi
-
-if isubuntu; then
-    # disable crash report annoying crap
-    s dd of=/etc/default/apport <<<'enabled=0'
+  fi
+  # the first pup command can kill off our /etc/ mod, so rerun this
+  /a/exe/ssh-emacs-setup
 fi
 
 
-pi ghc sakura
-# todo, also note for work comp, scp opt/org-mode bin/build-scripts
-
-# use the package manger version to install the cabal version
-pi cabal-install
-cabal update
-PATH="$PATH:$HOME/.cabal/bin"
-
-# todo, on older ubuntu I used cabal xmonad + xfce,
-# see /a/bin/old-unused/xmonad-cabal.sh
-
-# trying out the distro's versions newer distros
-    pi xmonad
-    if isarch; then
-        # for displaying error messages.
-        # optional dependency in arch, standard elsewhere.
-        pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
-
-        # https://wiki.archlinux.org/index.php/Xinitrc
-        cp /etc/X11/xinit/xinitrc ~/.xinitrc
-        sed -ri '/^ *twm\b/,$d' ~/.xinitrc
-        echo "source /a/bin/xinitrc" >> ~/.xinitrc
-    else
-        pi suckless-tools
-    fi
-pi dmenu
-
-if isdeb && (tp || x2); then
-    pi task-laptop
-fi
+echo 0 >~/.local/distro-begin
+echo "$0: $(date): ending now"
+exit 0